<?php			

	/**
	 *	Select user to edit
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */	

	// Include required modules
	require "inc/includer.inc.php";
	require_once("inc/admin.inc.php");
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLSELECTUSER);
	include "inc/header.inc.php";

	// Set variables
	$bError = FALSE;
	$strMessage = "";
	$strFilter = "";
	$iUserID = -1;
	
	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR']) != $_SESSION['admin'])	{ 

		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	// Get filter
	if(isset($_SESSION['s_UserFilter'])	&& !empty($_SESSION['s_UserFilter']))	{
		$strFilter = $_SESSION['s_UserFilter'];
	}
	

	//
	// Process form
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready'])=="YES")	{

		if(isset($_POST['f_usertoedit']))	{
			$iUserID = (integer)$_POST['f_usertoedit'];
		}
		
		
		switch(TRUE)	{
			case isset($_POST['f_filter']):

				// Filter user list
				$_POST['f_filterkey'] = toSafeString($_POST['f_filterkey']);
				if(!empty($_POST['f_filterkey']))	{
					$strFilter = $_POST['f_filterkey'];
					$_SESSION['s_UserFilter'] = $strFilter;
				}
				break;
			case isset($_POST['f_filterdelete']):
				
				// Delete user filter
				$strFilter = "";
				$_SESSION['s_UserFilter'] = "";
				unset($_SESSION['s_UserFilter']);			
			
				break;
			case isset($_POST['f_block']):
				
				// Blocking
				if($iUserID <=0)	{
					$bError = TRUE;
					$strMessage = LANG_EDITUSERNOUSERSELECTED;
				} else {
					ToogleBlockStatus($iUserID);
					$strMessage = LANG_GENERALEDITSUCCESS;
				}
			
				break;
			case isset($_POST['f_delete']):

				// Deleting
				if($iUserID<=0)	{
					$bError = TRUE;
					$strMessage = LANG_EDITUSERNOUSERSELECTED;
				} else {
					if(DeleteUser($iUserID, FALSE))	{
						// Delete okay, log action
						LogActions("USRD","User-ID: ".$iUserID.
							" - IP: ".$_SERVER['REMOTE_ADDR']);
						$strMessage = LANG_GENERALEDITSUCCESS;
					}
				}
			
				break;
			case isset($_POST['f_usergroup']):
				
				// Toogle age restricting
				if($iUserID<=0)	{
					$bError = TRUE;
					$strMessage = LANG_EDITUSERNOUSERSELECTED;
				} else {
					if(ToogleClosedUsergroup($iUserID))	{
						// Delete okay, log action
						$strMessage = LANG_GENERALEDITSUCCESS;		
					}
				}			
			
				break;
			case isset($_POST['f_rightauth']):

				// Auth right
				if($iUserID<=0)	{
					$bError = TRUE;
					$strMessage = LANG_EDITUSERNOUSERSELECTED;
				} else {
					if(ToogleAuthUser($iUserID))	{
						// Delete okay, log action
						$strMessage = LANG_GENERALEDITSUCCESS;		
					}
				}			
				break;

			case isset($_POST['f_edit']):

				// Edit message
				if($iUserID<=0)	{
					$strMessage = LANG_EDITUSERNOUSERSELECTED;
					$bError = TRUE;
				} else {
					$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; ".
						"URL=admin_edituserdetails.php?userid=".$iUserID."\">";
					include "inc/header.inc.php";
					die();
				}
				break;
		}
	
	} 
	

	//
	// Display template
	//
	$OptionList = BuildUserlistForListField($strFilter);
	if($OptionList == false)	{
		$OptionList = "<option value=\"-1\">".LANG_DBEMPTYTABLE."</option>";	
	}

	$_POST['f_filterkey'] = $strFilter;
	
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_edituser.tpl.php";
	include "inc/footer.inc.php";
?>