<?php			

	/**
	 *	Edit user data/settings
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */


	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	require_once("inc/admin.inc.php");
	
	

	// Only valid, if PHP is not in safe_mode!
	if(!(boolean)ini_get('safe_mode'))		{
		@set_time_limit(180);
	}
		
		
	function UpdateDatabase($UID=-1)		{

		if($UID <= 0)	{ return false; }
		
		// Update User database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			echo LAST_DBCONNECTERRORCUST;
			die();
		}
		$sql = BuildSQLString($UID);
		$RetVal = $DB->dbupdate($sql);
		if($RetVal)		{
			LogActions("USRE","User-ID: ".$UID." - Username: ".$_POST['f_name']);
		}
		return $RetVal;
	}

	function CalcUserRights()		{
		// Calculates User rights in bitwise form	
		$intRight = 0;
		if(isset($_POST['f_RightUser']) && strtoupper($_POST['f_RightUser'])=="YES")
			{ $intRight += 1; }
		if(isset($_POST['f_RightUserAuth']) && strtoupper($_POST['f_RightUserAuth'])=="YES")		
			{ $intRight += 2; }
		if(isset($_POST['f_RightUserComm']) && strtoupper($_POST['f_RightUserComm'])=="YES")		
			{ $intRight += 16; }
		if(isset($_POST['f_RightUserAdmin']) && strtoupper($_POST['f_RightUserAdmin'])=="YES")		
			{ $intRight += 64; }
		if(isset($_POST['f_RightUserDebug']) && strtoupper($_POST['f_RightUserDebug'])=="YES")		
			{ $intRight += 128; }
		return $intRight;
	}
	

	function BuildSQLString($UID)		{
		
		// Calculate the granted user rights
		$UserRights = CalcUserRights();

		// Build string
		$RetVal = "UPDATE cf_users SET ".
			"userrights=".$UserRights.",".
			"userdeflang='".$_POST['f_languageselect']."',".
			"userrealname='".$_POST['f_name']."',".
			"useradress1='".$_POST['f_address1']."',".
			"useradress2='".$_POST['f_address2']."',".
			"usertitle='".$_POST['f_title']."',".
			"userzip='".$_POST['f_zip']."',".
			"usercity='".$_POST['f_city']."',".
			"usertel='".$_POST['f_tel']."',".
			"userfax='".$_POST['f_fax']."',".
			"usermobile='".$_POST['f_mobile']."',".
			"usericq='".$_POST['f_icq']."',".
			"usermsn='".$_POST['f_msn']."',".
			"userskype='".$_POST['f_skype']."',".
			"useraim='".$_POST['f_aim']."',".
			"useryahoo='".$_POST['f_yahoo']."',".
			"usercountry='".$_POST['f_country']."',".
			"useremail='".$_POST['f_email']."',".
			"usereditdate=now(),".
			"userhomepage='".$_POST['f_website']."' ".
			"WHERE userid=".$UID;		

		return $RetVal;	
	}


	// Header senden
	$PageTitle = GetPageTitle(LANG_INPTTLADMEDTUSER);
	include "inc/header.inc.php";
	
	$UserTest = array( 	"usernametest"=>		TRUE,
						"passwordtest"=>		TRUE,
						"passwordtesttest"=>	TRUE,
						"nametest"=>			TRUE,
						"address1test"=>		TRUE,
						"ziptest"=>				TRUE,
						"citytest"=>			TRUE,
						"countrytest"=>			TRUE,
						"emailtest"=>			TRUE,
						"languageselecttest"=>	TRUE,
						"usertel"=>				TRUE,
						"useremail"=>			TRUE,
						"userfax"=>				TRUE,
						"usermobile"=>			TRUE,
						"userlastlogin"=>		TRUE
	);			
	
	$bError = FALSE;
	$strMessage = "";
	$iUserId = -1;
	
	
	//
	// Determine user id
	//
	if(isset($_GET['userid']))	{
		$iUserId = (integer)$_GET['userid'];
		$_SESSION['s_UserId'] = $iUserId;
	} elseif(isset($_SESSION['s_UserId']))	{
		$iUserId = (integer)$_SESSION['s_UserId'];
	}

	if($iUserId <= 0)	{
		ShowErrorMessage(LANG_PAGEPARAMETERERROR);
		die();
	}
	
	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR']) != $_SESSION['admin'])	{ 

		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}

	
	//
	// Get user data
	//
	$EditUserInfo = GetUserDetails($iUserId);
	if(!is_array($EditUserInfo))	{
		// Userdata could not be read from database
		echo "Error: Could not get user data!";
		die();
	}
	
	
	//
	//	Process form
	//	
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")	{
	
		// Convert input
		$_POST['f_languageselect'] = toSafeString($_POST['f_languageselect']);
		$_POST['f_name'] = toSafeString($_POST['f_name']);
		$_POST['f_address1'] = toSafeString($_POST['f_address1']);
		$_POST['f_address2'] = toSafeString($_POST['f_address2']);
		$_POST['f_title'] = toSafeString($_POST['f_title']);
		$_POST['f_zip'] = toSafeString($_POST['f_zip']);
		$_POST['f_city'] = toSafeString($_POST['f_city']);
		$_POST['f_tel'] = toSafeString($_POST['f_tel']);
		$_POST['f_fax'] = toSafeString($_POST['f_fax']);
		$_POST['f_mobile'] = toSafeString($_POST['f_mobile']);
		$_POST['f_icq'] = toSafeString($_POST['f_icq']);
		$_POST['f_yahoo'] = toSafeString($_POST['f_yahoo']);
		$_POST['f_aim'] = toSafeString($_POST['f_aim']);
		$_POST['f_msn'] = toSafeString($_POST['f_msn']);
		$_POST['f_skype'] = toSafeString($_POST['f_skype']);
		$_POST['f_website'] = CropProtocol($_POST['f_website']);
		$_POST['f_website'] = toSafeString($_POST['f_website']);
		$_POST['f_country'] = toSafeString($_POST['f_country']);
		$_POST['f_email'] = toSafeString($_POST['f_email']);
		
		
		// Check input variables
		if(empty($_POST['f_name']))		{ $UserTest['nametest']=false; }
		//if(empty($_POST['f_address1']))	{ $UserTest['address1test']=false; }
		if(empty($_POST['f_zip']))		{ $UserTest['ziptest']=false; }
		if(empty($_POST['f_city']))		{ $UserTest['citytest']=false; }
		if(empty($_POST['f_country']))	{ $UserTest['countrytest']=false; }
		if(empty($_POST['f_email']))	{ $UserTest['emailtest']=false; }
		if(empty($_POST['f_languageselect']))	{ $UserTest['languageselecttest']=false; }
	
		foreach($UserTest as $element)	{
			if($element == false)	{ 
				$bError = true; 
				$strMessage = LANG_NEWADMANDATORYERROR;
			}
		}
	
		// Test for password change
		if(!$bError && (!empty($_POST['f_password']) || !empty($_POST['f_passwordre'])))		{
			if($_POST['f_password']!=$_POST['f_passwordre'])	{
				// Password not the same
				$bError = true;
				$UserTest['passwordtest']=FALSE; 
				$UserTest['passwordretest']=FALSE;
				$strMessage = LANG_NEWUSERPASSWORDERROR;
			}				
		}
		
		// Check form for plausibility
		// Email valid?
		if(!$bError)		{
			if (!eregi(REGEX_EMAILCHECK,$_POST['f_email']))		{
					$UserTest['f_email']=false;
				$bError = TRUE;
				$strMessage = LANG_NEWADEMAILERROR;
			}
		}	
			
		if(!$bError)		{
			$RetVal = UpdateDatabase($iUserId);
			if(!$RetVal)	{
				$bError = TRUE;
				$strMessage = LANG_GENERALEDITERROR;
			} else {
				// Everything worked fine...
				$strMessage = LANG_ADMEDITUSERUPDATESUC;
				$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin_edituser.php\">";
		  		 // If Redirect fails, show a message and an return link	
//				include "inc/header.inc.php";
			}
		}
			
		// Build user stats
		$strSumOfAds = ParseIn(LANG_USERINFOSUMOFADS, $_SESSION['s_SummaryArray']['AdSum']);
		$strViewsOfAds = ParseIn(LANG_USERINFOVIEWSOFADS, $_SESSION['s_SummaryArray']['ViewSum']);
		$strContsOfAds = ParseIn(LANG_USERINFOCONTSOFADS, $_SESSION['s_SummaryArray']['ContSum']);
		$strTellsOfAds = ParseIn(LANG_USERINFOTELLSOFADS, $_SESSION['s_SummaryArray']['TellSum']);
		$strFeatsOfAds = ParseIn(LANG_USERINFOFEATSOFADS, $_SESSION['s_SummaryArray']['FeatSum']);
		$strNumOfLogins = ParseIn(LANG_USERINFONOLOGINS, $_SESSION['s_NumOfLogins']);
			
	} else {

		// Fill form fields
		$_POST['f_username'] = $EditUserInfo['username'];
		$_POST['f_title'] = $EditUserInfo['usertitle'];
		$_POST['f_name'] = $EditUserInfo['userrealname'];
		$_POST['f_address1'] = $EditUserInfo['useradress1'];
		$_POST['f_address2'] = $EditUserInfo['useradress2'];
		$_POST['f_zip'] = $EditUserInfo['userzip'];
		$_POST['f_icq'] = $EditUserInfo['usericq'];
		$_POST['f_yahoo'] = $EditUserInfo['useryahoo'];
		$_POST['f_msn'] = $EditUserInfo['usermsn'];
		$_POST['f_aim'] = $EditUserInfo['useraim'];
		$_POST['f_skype'] = $EditUserInfo['userskype'];
		$_POST['f_city'] = $EditUserInfo['usercity'];
		$_POST['f_country'] = $EditUserInfo['usercountry'];
		$_POST['f_email'] = $EditUserInfo['useremail'];
		$_POST['f_website'] = $EditUserInfo['userhomepage'];
		$_POST['f_mobile'] = $EditUserInfo['usermobile'];
		$_POST['f_tel'] = $EditUserInfo['usertel'];
		$_POST['f_fax'] = $EditUserInfo['userfax'];
		$_POST['f_languageselect'] = $EditUserInfo['userdeflang'];
		
		$_POST['f_RightUser'] = ($EditUserInfo['userrights'] & 1?"YES":"");
		$_POST['f_RightUserAuth'] = ($EditUserInfo['userrights'] & 2?"YES":"");
		$_POST['f_RightUserComm'] = ($EditUserInfo['userrights'] & 16?"YES":"");
		$_POST['f_RightUserAdmin'] = ($EditUserInfo['userrights'] & 64?"YES":"");
		$_POST['f_RightUserDebug'] = ($EditUserInfo['userrights'] & 128?"YES":"");
		
		
		// Build User stats and save to session
		$arrSum = GetUserSummary($iUserId);
		$_SESSION['s_NumOfLogins'] = $EditUserInfo['userlogins'];
		
		// Build user stats strings
		$strSumOfAds = ParseIn(LANG_USERINFOSUMOFADS, $arrSum['AdSum']);
		$strViewsOfAds = ParseIn(LANG_USERINFOVIEWSOFADS, $arrSum['ViewSum']);
		$strContsOfAds = ParseIn(LANG_USERINFOCONTSOFADS, $arrSum['ContSum']);
		$strTellsOfAds = ParseIn(LANG_USERINFOTELLSOFADS, $arrSum['TellSum']);
		$strFeatsOfAds = ParseIn(LANG_USERINFOFEATSOFADS, $arrSum['FeatSum']);
		$strNumOfLogins = ParseIn(LANG_USERINFONOLOGINS, $_SESSION['s_NumOfLogins']);
		$_SESSION['s_SummaryArray'] = $arrSum;
	}
	
	//
	// Display from
	//
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".
		LANG_TTLMYUSERSETTINGS;
	$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
	$strCountrySelect = GetCountriesForDropDown($_POST['f_country']);
	$strLangSelect = GetAvailLang(true, $_POST['f_languageselect']);
	
	$strUsername = $EditUserInfo['username'];
	$strUserCreate = FormatDate($EditUserInfo['usercreatedate']);
	$strLastLogin = FormatDate($EditUserInfo['userlastlogin']);
	
	
	// Show Template
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_edituserdetails.tpl.php";
	include "inc/footer.inc.php";

?>