<?php	

	/**
	 *	Install database tables
	 * 
	 * 	Please change database settings in config.inc.php first 
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require "inc/configmanager.class.php";
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMINUPDATEDB);
	include "inc/header.inc.php";
	
	$bError = false;
	$strMessage = "";
	$strLog = "";
	
	$strServer = GetConfig('DB_HOST');
	$strDatabase = GetConfig('DB_NAME');
	$strDatabaseUser = GetConfig('DB_USER');
	
	
	//
	// Process installation
	//	
	if(isset($_POST['f_send']) && strtoupper($_POST['f_send'])=="YES")	{
		
		//
		// Check mandatory settings
		//
		if(empty($strServer) || empty($strDatabase))	{
			$bError = TRUE;
			$strLog = "Please check database server/host and database settings in configuration.";
		}
		
		if(!$bError)	{		
		
			// Connect database
			$DB = new SQLDatabase();
			$DB->dbconnect();
		
			if(!$DB->IsConnected())	{
				$bError = TRUE;
				$strLog = LANG_DBCONNECTERROR."<br>".
					$DB->GetErrorMessage();
			} elseif($DB->GetError()!=0)	{
				$bError = TRUE;
				$strLog = ParseIn(LANG_DBCOMMONERROR,$DB->GetErrorMessage())."<br>".
					$DB->GetErrorMessage();
			} else {
				
				// Create picture table			
				$sql = "CREATE TABLE `cf_pictures` (
				  `plid` int(11) NOT NULL auto_increment,
				  `pladid` int(11) NOT NULL default '0',
				  `pltitle` varchar(100) NOT NULL default '',
				  `pllink` varchar(80) NOT NULL,
				  `plinsertdate` datetime NOT NULL,
				  `plreleased` tinyint(1) NOT NULL default '0',
				  PRIMARY KEY  (`plid`),
				  KEY `pladid` (`pladid`),
				  KEY `plreleased` (`plreleased`)
				) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"picture detail table cf_pictures")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};			
				
				// Alter user table
				$sql = "ALTER TABLE `cf_users` ADD `useremailhtml` TINYINT(1) DEFAULT '1' NOT NULL";

				$strLog.= ParseIn(LANG_TBLCREATER,"User table cf_users")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				// Convert picture links	
				$strLog.= "Converting pictures to new scheme...<br>";
						
				$sql = "SELECT adid,adpiclink,adtitle
					FROM cf_ads
					WHERE adpiclink!='' 
					ORDER BY adid DESC";
				$data = $DB->dbselect($sql);
				
				if(is_array($data) && sizeof($data)>0)		{

					$sql = "DELETE FROM cf_pictures";
					$DB->dbdelete($sql);
					
					// Insert pic information into picture table
					foreach($data as $element)	{
						$sql = "INSERT INTO cf_pictures 
							(pladid,pltitle,pllink,plinsertdate,plreleased)	VALUES (".
							$element['adid'].",'".$element['adtitle']."','".
							$element['adpiclink']."',now(),1)";
						$DB->dbinsert($sql);						
					}
				}
				
				
				// Install and convert configuration
				$sql = "CREATE TABLE `cf_config` (
				  	`configid` int(11) NOT NULL auto_increment,
				  	`configname` varchar(50) NOT NULL,
				  	`configspec` text NOT NULL,
				 	`configdefault` tinyint(1) NOT NULL default '0',
				  	`configactive` tinyint(1) NOT NULL default '0',
				  	`configeditdate` datetime default NULL,
				  	`configversion` int(11) NOT NULL default '1',
				  	PRIMARY KEY  (`configid`)
					) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"configuration table cf_config")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};			
				
						
				$strLog.= "Inserting default configuration...<br>";

				$sql = "DELETE FROM cf_config";
				$iAffRows = $DB->dbdelete($sql);				
				
				$sql = "INSERT INTO `cf_config` 
					(`configid`, `configname`, `configspec`, `configdefault`, `configactive`, `configeditdate`, `configversion`)			
					VALUES (1,'ClassAd Standard',
					'a:81:{s:7:\"DB_NAME\";s:0:\"\";s:7:\"DB_HOST\";s:9:\"127.0.0.1\";
					s:7:\"DB_USER\";s:4:\"root\";s:7:\"DB_PASS\";s:0:\"\";s:7:\"DB_TYPE\";s:1:\"1\";s:9:\"ADMINNAME\";s:5:\"admin\";
					s:9:\"ADMINPASS\";s:32:\"21232f297a57a5a743894a0e4a801fc3\";s:13:\"LY_STYLESHEET\";s:16:\"styles/green.css\";
					s:20:\"LY_ENABLEARTICLEPICS\";b:1;s:15:\"LY_GD_VERSION_2\";b:1;s:18:\"LY_THUMBNAIL_WIDTH\";s:2:\"75\";
					s:19:\"LY_THUMBNAIL_HEIGHT\";s:2:\"75\";s:16:\"LY_MAX_PIC_WIDTH\";s:3:\"500\";s:17:\"LY_MAX_PIC_HEIGHT\";
					i:500;s:17:\"LY_ALLOW_UPSIZING\";b:0;s:17:\"LY_MAX_LISTLENGTH\";i:20;s:27:\"LY_ARTLIST_VARIABLE_BGCOLOR\";
					b:1;s:18:\"LY_MAX_UPLOAD_SIZE\";s:3:\"300\";s:18:\"LY_SORT_ORDER_CATS\";s:1:\"2\";s:19:\"LY_BIG_PICTURE_MODE\";
					b:0;s:12:\"ML_ADMINCOPY\";b:0;s:13:\"ML_ADMINEMAIL\";s:19:\"thomas@schaeper.org\";s:18:\"ML_RESPONDVIAEMAIL\";
					b:0;s:14:\"ML_SENDER_NAME\";s:18:\"Kleinanzeigenmarkt\";s:14:\"ML_SENDER_ADDR\";s:20:\"someone@somehost.com\";
					s:9:\"ML_DOMAIN\";s:12:\"somehost.com\";s:13:\"ML_EMAIL_HTML\";b:1;s:22:\"ML_PROVIDER_SHORT_INFO\";
					s:28:\"My Name, My Address, My City\";s:9:\"PD_WEBURL\";s:16:\"www.somehost.com\";s:13:\"PD_SCRIPTPATH\";
					s:12:\"classifieds/\";s:15:\"PD_USERGRAPHICS\";s:13:\"usergraphics/\";s:17:\"PD_SCRIPTGRAPHICS\";
					s:9:\"graphics/\";s:14:\"PD_DIRCATLOGOS\";s:9:\"catlogos/\";s:17:\"PD_EMAILTEMPLATES\";s:15:\"emailtemplates/\";
					s:11:\"PD_CACHEDIR\";s:6:\"cache/\";s:13:\"RSS_MAX_COUNT\";i:20;s:9:\"RSS_TITLE\";
					s:26:\"Latest ads from www.xyz.de\";s:15:\"RSS_DESCRIPTION\";s:69:\"The latest ads from www.xyz.de. Classified ads for all kind of goods.\";
					s:8:\"RSS_ICON\";s:9:\"world.jpg\";s:7:\"RSS_TTL\";i:60;s:18:\"SEC_FORCE_AGE_REST\";b:1;
					s:21:\"SEC_HIDE_AGEREST_CATS\";b:1;s:20:\"SEC_HIDE_AGEREST_ADS\";b:1;s:15:\"SEC_SUB_UNKNOWN\";
					b:0;s:19:\"SEC_DIR_SUB_UNKNOWN\";b:0;s:16:\"SEC_DIR_SUB_USER\";b:0;s:20:\"SEC_DIR_SUB_AUTHUSER\";
					b:1;s:22:\"SEC_DIR_SUB_COMMERCIAL\";b:1;s:18:\"SEC_SUB_ADMIN_INFO\";b:1;s:17:\"SEC_REGUSER_OPTIN\";
					b:1;s:18:\"SEC_MAX_TELL_COUNT\";s:2:\"20\";s:19:\"SEC_USE_PIC_RELEASE\";b:1;s:19:\"SEC_MAX_PICS_PER_AD\";
					i:5;s:14:\"OP_SIMPLE_CATS\";s:1:\"0\";s:20:\"OP_COMPLEX_CATS_COLS\";s:1:\"2\";s:22:\"OP_COMPLEX_CATS_MAXSUB\";
					s:1:\"5\";s:29:\"OP_COMPLEX_CATS_SUB_ART_COUNT\";b:1;s:27:\"OP_COMPLEX_CATS_BUILD_ORDER\";s:1:\"1\";
					s:21:\"OP_BUILD_FEATURED_ADS\";b:1;s:24:\"OP_BUILD_FEATURED_NO_ADS\";s:1:\"3\";s:19:\"OP_BUILD_LATEST_ADS\";
					b:1;s:22:\"OP_BUILD_LATEST_NO_ADS\";s:1:\"5\";s:22:\"OP_SHOW_PAGE_BUILDTIME\";b:1;s:10:\"DOMAINNAME\";
					s:12:\"somehost.com\";s:6:\"TELLAD\";b:1;s:10:\"ICQCONTACT\";b:0;s:7:\"CRONJOB\";b:0;s:20:\"MAINTAIN_PROBABILITY\";
					i:100;s:18:\"AUTODELETEOUTDATED\";b:0;s:13:\"ALLOW_CACHING\";b:1;s:13:\"UNLIMITED_ADS\";
					b:1;s:15:\"USE_FREE_FIELDS\";b:0;s:15:\"BUFFERED_OUTPUT\";b:1;s:7:\"DEFLANG\";s:3:\"GER\";
					s:10:\"DEFCOUNTRY\";s:1:\"D\";s:11:\"DEFMAILLANG\";s:3:\"GER\";s:5:\"DEBUG\";b:0;s:7:\"VERSION\";s:4:\"4.50\";
					s:17:\"LY_RSS_MAX_LENGTH\";i:200;s:14:\"RSS_MAX_LENGTH\";i:200;s:23:\"SEC_USE_PICTURE_RELEASE\";b:1;}',
					1,0,now(),1)";
				$iInsertId = $DB->dbinsert($sql);
				
				if($iInsertId<=0)	{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_INSTALL_INSERT_ERR,"cf_config",$DB->GetErrorMessage());
				} else {
					$oConfigMan = new ConfigManager();
					$bConfigError = FALSE;
					
					if(!$oConfigMan->ReadSpecialConfig(CONFIGMANAGER_ACTIVE))	{
				
						if(!$oConfigMan->ReadSpecialConfig(CONFIGMANAGER_DEFAULT))	{
							$bConfigError = TRUE;
							$bError = TRUE;
							$strLog.= "Missing active / default configuration(s).";
							$strMessage = "No base configuration found. Please make sure database tables are installed correctly.";
						}
					}
					
					if(!$bConfigError)	{
						
						$oConfigMan->SetConfigVar("DB_NAME",$GLOBALS['DB_NAME']); 
						$oConfigMan->SetConfigVar("DB_HOST",$GLOBALS['DB_HOST']);
						$oConfigMan->SetConfigVar("DB_USER",$GLOBALS['DB_USER']);
						$oConfigMan->SetConfigVar("DB_PASS",$GLOBALS['DB_PASS']);
						$oConfigMan->SetConfigVar("ADMINNAME",$GLOBALS['ADMINNAME']);
						$oConfigMan->SetConfigVar("ADMINPASS",md5($GLOBALS['ADMINPASS']));
						$oConfigMan->SetConfigVar("LY_STYLESHEET",$GLOBALS['LY_STYLESHEET']);
						$oConfigMan->SetConfigVar("LY_THUMBNAIL_WIDTH",$GLOBALS['LY_THUMBNAIL_WIDTH']);
						$oConfigMan->SetConfigVar("LY_THUMBNAIL_HEIGHT",$GLOBALS['LY_THUMBNAIL_HEIGHT']);
						$oConfigMan->SetConfigVar("LY_MAX_PIC_WIDTH",$GLOBALS['LY_MAX_PIC_WIDTH']);
						$oConfigMan->SetConfigVar("LY_MAX_PIC_HEIGHT",$GLOBALS['LY_MAX_PIC_WIDTH']);
						$oConfigMan->SetConfigVar("ML_ADMINEMAIL",$GLOBALS['ML_ADMINEMAIL']);
						$oConfigMan->SetConfigVar("ML_SENDER_NAME","Anzeigenmarkt");
						$oConfigMan->SetConfigVar("ML_SENDER_ADDR","webmaster@".$GLOBALS['DOMAINNAME']);
						$oConfigMan->SetConfigVar("ML_DOMAIN",$GLOBALS['DOMAINNAME']);
						$oConfigMan->SetConfigVar("ML_PROVIDER_SHORT_INFO","Put your contact details here (Name, Adresse etc.)");
						$oConfigMan->SetConfigVar("PD_WEBURL",$GLOBALS['PD_WEBURL']);
						$oConfigMan->SetConfigVar("PD_SCRIPTPATH",$GLOBALS['PD_SCRIPTPATH']);
						$oConfigMan->SetConfigVar("PD_USERGRAPHICS",$GLOBALS['PD_USERGRAPHICS']);
						$oConfigMan->SetConfigVar("PD_SCRIPTGRAPHICS",$GLOBALS['PD_SCRIPTGRAPHICS']);
						$oConfigMan->SetConfigVar("PD_DIRCATLOGOS",$GLOBALS['PD_DIRCATLOGOS']);
						$oConfigMan->SetConfigVar("PD_EMAILTEMPLATES",$GLOBALS['PD_EMAILTEMPLATES']);
						$oConfigMan->SetConfigVar("PD_CACHEDIR",$GLOBALS['PD_CACHEDIR']);
						$oConfigMan->SetConfigVar("RSS_TITLE",$GLOBALS['RSS_TITLE']);
						$oConfigMan->SetConfigVar("RSS_DESCRIPTION",$GLOBALS['RSS_DESCRIPTION']);
						$oConfigMan->SetConfigVar("RSS_ICON",$GLOBALS['RSS_ICON']);
						$oConfigMan->SetConfigVar("SEC_SUB_UNKNOWN",$GLOBALS['SEC_SUB_UNKNOWN']);
						$oConfigMan->SetConfigVar("SEC_DIR_SUB_UNKNOWN",$GLOBALS['SEC_DIR_SUB_UNKNOWN']);
						$oConfigMan->SetConfigVar("SEC_DIR_SUB_USER",$GLOBALS['SEC_DIR_SUB_USER']);
						$oConfigMan->SetConfigVar("SEC_DIR_SUB_AUTHUSER",$GLOBALS['SEC_DIR_SUB_AUTHUSER']);
						$oConfigMan->SetConfigVar("SEC_DIR_SUB_COMMERCIAL",$GLOBALS['SEC_DIR_SUB_COMMERCIAL']);
						$oConfigMan->SetConfigVar("SEC_REGUSER_OPTIN",$GLOBALS['SEC_REGUSER_OPTIN']);
						$oConfigMan->SetConfigVar("OP_SIMPLE_CATS",$GLOBALS['OP_SIMPLE_CATS']);
						$oConfigMan->SetConfigVar("OP_COMPLEX_CATS_COLS",$GLOBALS['OP_COMPLEX_CATS_COLS']);
						$oConfigMan->SetConfigVar("OP_COMPLEX_CATS_MAXSUB",$GLOBALS['OP_COMPLEX_CATS_MAXSUB']);
						$oConfigMan->SetConfigVar("OP_COMPLEX_CATS_BUILD_ORDER",$GLOBALS['OP_COMPLEX_CATS_BUILD_ORDER']);
						$oConfigMan->SetConfigVar("DOMAINNAME",$GLOBALS['DOMAINNAME']);
						$oConfigMan->SetConfigVar("CRONJOB",$GLOBALS['CRONJOB']);
						$oConfigMan->SetConfigVar("MAINTAIN_PROBABILITY",$GLOBALS['MAINTAIN_PROBABILITY']);
						$oConfigMan->SetConfigVar("AUTODELETEOUTDATED",$GLOBALS['AUTODELETEOUTDATED']);
						$oConfigMan->SetConfigVar("DEFLANG",$GLOBALS['DEFLANG']);
						$oConfigMan->SetConfigVar("DEFMAILLANG",$GLOBALS['DEFMAILLANG']);
						$oConfigMan->SetConfigVar("DEFCOUNTRY",$GLOBALS['DEFCOUNTRY']);
						$oConfigMan->SetConfigVar("USE_FREE_FIELDS",$GLOBALS['USE_FREE_FIELDS']);
						$oConfigMan->SetConfigVar("UNLIMITED_ADS",$GLOBALS['UNLIMITED_ADS']);
						$oConfigMan->SetConfigVar("ALLOW_CACHING",$GLOBALS['ALLOW_CACHING']);
						$oConfigMan->SetConfigVar("VERSION","4.50");
						$oConfigMan->SetConfigVar("OP_BUILD_FEATURED_ADS",TRUE);
						$oConfigMan->SetConfigVar("OP_BUILD_LATEST_ADS",TRUE);
											
						$oConfigMan->UpdateConfig(CONFIGMANAGER_DEFAULT);	
						
						// Update configuration in database and compile the config file
						$oConfigMan->bDefault = FALSE; 
						$oConfigMan->strName = "Active configuration";
						$oConfigMan->UpdateConfig(CONFIGMANAGER_ACTIVE);
						$oConfigMan->SaveConfigToFile("config/config.inc.php",TRUE);			
						
						if($bError)		{
							$strMessage = LANG_DBINSTALLFAILED;	
						} else {
							$strMessage = LANG_DBINSTALLOKAY;		
						}
					}
				}
				$strLog.= "Conversion done.";
			}
					
		}

		if($bError)		{
			$strMessage = LANG_DBINSTALLFAILED;
		} else {
			
			//
			// All tables created
			//
			$strMessage = LANG_DBINSTALLOKAY;
		}
		
	} else {

		// First display
		// Set defaults	
		$strLog = "* ATTENTION *<br>".
			"<b>This script converts the database from ClassAd Version 4.0x to 4.5. Be assure the database is backed up before starting installation.</b>";
	}
	
	//
	// Display template
	//
	$strPw = GetConfig('DB_PASS');
	$strPassword = !empty($strPw)?"Yes":"No";

	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_update.tpl.php";
	include "inc/footer.inc.php";
	
?>