<?php		

	/**
	 *	Show imprint
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	
	
	// Include everything classAd needs
	require "inc/includer.inc.php";

	// Build header information
	$PageTitle = GetPageTitle(LANG_TTLCONTACT);
	include "inc/header.inc.php";	
	include "inc/postoffice.class.php";
	
	
	//
	// Init variables
	//
	$bError = FALSE;
	$strMessage = "";

	$ContactTest = array(	"nametest"		=> TRUE,
							"emailtest"		=> TRUE,
							"messagetest"	=> TRUE	);
	
	//
	// Process form
	//
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES" )		{

		
		// Convert input
		$_POST['f_title'] = toSafeString($_POST['f_title']);
		$_POST['f_name'] = toSafeString($_POST['f_name']);
		$_POST['f_email'] = substr(toSafeString($_POST['f_email']),0,40);
		$_POST['f_message'] = toSafeString($_POST['f_message']);
		
		// Check mandatory fields and email
		if(empty($_POST['f_name']))	{	$ContactTest['nametest'] = FALSE; }
		if(empty($_POST['f_email']))	{	$ContactTest['emailtest'] = FALSE; }
		if(empty($_POST['f_message']))	{	$ContactTest['messagetest'] = FALSE; }
		
		if(empty($_POST['f_name']) || empty($_POST['f_email']) || empty($_POST['f_message']))		{ 
			$bError = TRUE; 
			$strMessage = LANG_NEWADMANDATORYERROR;
		}
		
		if(!$bError)	{
			if(!eregi(REGEX_EMAILCHECK,$_POST['f_email']))	{
				$ContactTest['emailtest'] = FALSE;
				$bError = TRUE;
				$strMessage = LANG_NEWADEMAILERROR;
			}
		}
		
		// Check captcha
		if(GetConfig("USE_CAPTCHA"))	{
			if(!$bError)	{
				if(!isset($_SESSION['CAPTCHA']) || 
					(sha1(strtoupper($_POST['f_captcha'])) != $_SESSION['CAPTCHA']['SOLUTION']))	{
					
					$ContactTest['captchatest'] = FALSE;
					$bError = TRUE;
					$strMessage = LANG_CAPTCHA_ERROR;
				}			
			}
		}
		
		// process email
		if(!$bError)	{

			$arrMail = array( 	"ContTitle"		=> $_POST['f_title'],
								"ContName"		=> $_POST['f_name'],
							 	"ContEmail"		=> $_POST['f_email'],
							 	"ContText"		=> $_POST['f_message']);

			// Send mail		
			$PO = new PostOfficeContact($arrMail);
			$bSuccess = $PO->Send();			
			
			if(!$bSuccess)		{
				$bError = TRUE;
				$strMessage = LANG_SENDMAILFAILED;
			} else {
				
				unset($_SESSION['CAPTCHA']);
				
				$strMessage = LANG_SENDMAILSUCCESS;
				include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
				include "inc/footer.inc.php";
				die();
			}
		} 
		
	} else {
		
		if(isset($_SESSION['s_UserInfo']))	{
			$_POST['f_title'] = $_SESSION['s_UserInfo']['usertitle']; 
			$_POST['f_name'] = $_SESSION['s_UserInfo']['userrealname'];  
			$_POST['f_email'] = $_SESSION['s_UserInfo']['useremail'];  
		}
		
		if(GetConfig("USE_CAPTCHA"))	{
			
			// Create new captcha
			require_once("inc/textcaptcha.class.php");
			
			$oCaptcha = new TextCaptcha();
			$oCaptcha->SetMaxChars(GetConfig("CAPTCHA_CHARS"));
			$oCaptcha->BuildCaptcha();
			$_SESSION['CAPTCHA'] = array( 	"QUESTION"	=> $oCaptcha->GetQuestion(),
											"SOLUTION"	=> sha1(strtoupper($oCaptcha->GetSolution()))	);
		}		
		
	}

	
	// Build output vars
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_TTLCONTACT;
	$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
	
	// Add captcha
	if(GetConfig("USE_CAPTCHA"))		{
		$strCaptcha = $_SESSION['CAPTCHA']['QUESTION'];
	}
	
	// Send show template
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/contact.tpl.php";
	include "inc/footer.inc.php";
	
?>