<?php

	if (!defined('__COMMONDATE_INC__')) {
   		define('__COMMONDATE_INC__', 1);	

   		
		function FormatDate($DateIn, $Lang="", $JustDate=true)		{
			$DateOut = "";	
	
			if($Lang=="")	{ $Lang = GetConfig('DEFLANG'); }
			if(empty($DateIn) || $DateIn=="-1")	{$DateIn="2000-01-01"; }
						
			if($JustDate == true)		{
				list($jahr, $monat, $tag) = explode("-", $DateIn);
				return sprintf(LOCALE_DATE,$jahr,$monat,$tag);
	  		} else {
				list($jahr, $monat, $tag) = explode("-", $DateIn);
		   		list($stunde,$minute,$sekunde) = @explode(":",substr($DateIn,strpos($DateIn," ")+1));
	  		 	return sprintf(LOCALE_DATETIME,$jahr,$monat,$tag,$stunde,$minute,$sekunde);
			}	
		}
		
		
		//
		// Format a timestamp to user-readable output
		//
		function FormatDateDt($dtDateIn,$bJustDate=TRUE)	{
			if(empty($dtDateIn))	{
				$dtDateIn = mktime();
			}
			
			$arrDate = getdate($dtDateIn);		
			if($bJustDate)	{
				return sprintf(LOCALE_DATE, $arrDate['year'], $arrDate['mon'], $arrDate['mday']);
			} else {
				return sprintf(LOCALE_DATETIME, 
					$arrDate['year'], $arrDate['mon'], $arrDate['mday'],
					$arrDate['hours'],$arrDate['minutes'],$arrDate['seconds']);
			}
		}
		
		
		//
		// Format MySQL-Date to timestamp
		//
		function MysqlToTime($strDate,$bDateOnly=FALSE)	{
			$dtRet = mktime(0,0,0,1,1,2000);
			if($bDateOnly)		{
				list($iYear, $iMonth, $iDay) = explode("-", $strDate);
		   		$dtRet = mktime(0,0,0,$iMonth,$iDay,$iYear);
	  		} else {
				list($iYear, $iMonth, $iDay) = explode("-", $strDate);
		   		list($iHour,$iMinute,$iSec) = @explode(":",substr($strDate,strpos($strDate," ")+1));
				$dtRet = mktime($iHour, $iMinute, $iSec, $iMonth, $iDay, $iYear);	
			}
			
			// Return the date
			return $dtRet;
		}

		
		//
		// Format a timestamp to mySQL DateTime
		//
		function TimeToMysql($dtTime,$bDateOnly=FALSE)	{
			if($bDateOnly)	{
				$strRet = date("Y-m-d H:i:s",$dtTime);	
			} else {
				$strRet = date("Y-m-d",$dtTime);			
			}
			return $strRet;
		}
		
				
		//
		// Calculate the (absolute) days between two dates
		// Not very exact, just a rough estimation
		//
		function DaysBetweenDays($dtDate1,$dtDate2="")	{
			if(empty($dtDate2))	{
				$dtDate2 = mktime();
			}
	
			// Get date array
			$arrDate1 = getdate($dtDate1);
			$arrDate2 = getdate($dtDate2);
			
			// Calculate the days				
			$iDays = (($arrDate2['year']-$arrDate1['year'])*365.25)+
				(($arrDate2['mon']-$arrDate1['mon'])*30.4)+
				($arrDate2['mday']-$arrDate1['mday']);
		
			return (integer)abs($iDays);
		}
		
	
		// to mysql
		function toMysqlDate($iDay, $iMonth, $iYear)	{
			return (sprintf("%04d-%02d-%02d",$iYear,$iMonth,$iDay));
		}
		

		function toMysqlToArray($dtMysql)	{
			list($iYear, $iMonth, $iDay) = explode("-", $dtMysql);
		 	$arrRet = array(	"YEAR"	=> (isset($iYear)?$iYear:2000),
		 						"MONTH"	=> (isset($iMonth)?$iMonth:1),
		 						"DAY"	=> (isset($iDay)?$iDay:1));
		 	return $arrRet;
		}
	}	
	
?>