<?php

	/**
	 * PictureList
	 * 
	 * @todo 	Delete pictures has to delete picture from filesystem 
	 *
	 */
	class PictureList	{	

		var $arrList = array();
		
		/*
			Insert/remove from data structure
		*/	
		function AddPicture(&$oPic)	{
			$this->arrList[] = $oPic;
			return TRUE;
		}
		
		function RemovePicture($iIndex)	{
			if(isset($this->arrList[$iIndex]))
				unset($this->arrList[$iIndex]);
			return TRUE;
		}
		
		function GetFirstLink()		{
			if(sizeof($this->arrList)==0)	{
				return "";
			}
			return ($this->arrList[0]->strLink);		
		}
		
		
		function GetPicArray()	{
			return $this->arrList;
		}

		function Count()	{
			return sizeof($this->arrList);
		}
		
		/*	
			Array handling
		*/
		function RemoveByArray($arrIds)	{ 
			$arrNew = array();
			
			foreach($this->arrList as $key=>$oPic)	{
				if(!in_array($oPic->iId,$arrIds))	{
					$arrNew[] = $oPic;
				}
			}
			$this->arrList = $arrNew;		
		}
		
	
		/*
			O/R-Mapping
		*/
		function InsertList($iAdId)	{
			if(sizeof($this->arrList)==0)	{ return TRUE; }

			foreach($this->arrList as $oPic)	{
				$oPic->iAdId = $iAdId;
				$oPic->Insert();			
			}
			return TRUE;
		}
		
		
		/*
			Delete from database
		*/
		function Delete()	{
			foreach($this->arrList as $oPic)	{
				$oPic->Delete();
			}
			$this->arrList = array();
			return TRUE;						
		}
		
				
		/*
			Get picture list for a give ad
		*/	
		function ReadList($iAdId)	{
			
			$this->arrList = array();
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{ return FALSE; }

			$sql = "SELECT cf_pictures.* FROM cf_pictures WHERE pladid=".$iAdId." ORDER BY plinsertdate";
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				foreach($data as $element)	{
					$oPic = new Picture();
					$oPic->MapData($element);
					$this->AddPicture($oPic);
				}		
			} 
			return TRUE;
		}
	}
	
	
	class PictureListUnreleased	extends PictureList	{

		var $iAdId=-1;
		
		function PictureListUnreleased($iAdId=-1)		{
			$this->iAdId = $iAdId;
		}
		

		function ReadList()	{

			$this->arrList = array();
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{ return FALSE; }
			
			$sql = "SELECT cf_pictures.* 
				FROM cf_pictures
				WHERE plreleased=0 ".
				((integer)$this->iAdId>0?"AND pladid=".$this->iAdId." ":"").
				"ORDER BY pladid, plinsertdate DESC ".
				"LIMIT 500";
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				foreach($data as $element)	{
					$oPic = new Picture();
					$oPic->MapData($element);
					$this->AddPicture($oPic);
				}		
			} 
			return TRUE;
		}
		
		
		function Release($arrIds,$bRelease=TRUE)	{
			if(!is_array($arrIds))	{
				return FALSE;
			}
			
			if(sizeof($arrIds)>0)	{
						
				$DB = new SQLDatabase();
				if(!$DB->dbconnect())	{ return FALSE; }
				
				$sql = "UPDATE cf_pictures SET 
					plreleased=".($bRelease?"1":"0")." 
					WHERE plid IN (".implode(",",$arrIds).")";
				
				$iAffRows = $DB->dbupdate($sql);
				if($iAffRows<=0)	{				
					return FALSE;				
				}
			}
			return TRUE;
		}

		
	}
	
?>