<?php		

	/**
	 *	Search ads (simple)
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */

	require "inc/includer.inc.php";
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLSEARCHAD);
	include "inc/header.inc.php";
	
	//
	// Init variables
	//
	$LinkBack ="";
	$bError = FALSE;
	$strMessage = "";
	$BreadCrumb = "";
	$iSortOrder = AD_ORDER_INDATE_DESC;
	$data = array();
	
	
	//
	// Process form
	//
	if(isset($_GET['search']) && strtoupper($_GET['search'])=="YES")		{	
		
		if(isset($_GET['btnSetSort']))	{
			$iSortOrder = (integer)$_POST['f_sortorder'];
			$_SESSION['s_AdSortOrder'] = $iSortOrder;
		}
		
		// Open Database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			echo LANG_DBCONNECTERRORCUST;    
			die();
		}
	
		// Clear search key
		$_GET['searchkey'] = toSafeString($_GET['searchkey'], TRUE);
		if(isset($_GET['searchtype']))	{
			$_GET['searchtype'] = toSafeString($_GET['searchtype']);
		} else {		
			$_GET['searchtype'] = "AND";
		}
		
		if(empty($_GET['searchkey']))	{

			$bError = TRUE;
			$strMessage = LANG_SRCHNOKEY;
		
		} else {
			
			//
			// Build query
			//
			
			// Base query
			$sql = "SELECT cf_ads.*, ".
				"cf_categories.catname, cf_categories.catagerestricted as CatRest ".
				"FROM cf_ads ".
				"LEFT OUTER JOIN cf_categories ON (cf_ads.adcat = cf_categories.catid) ";
			
			// Filter 
			
			// Security		
			$sql .= "WHERE adchecked=1 ";

			if(GetConfig('SEC_HIDE_AGEREST_ADS') && GetConfig('SEC_FORCE_AGE_REST'))	{
				if(!isset($_SESSION['s_UserInfo']['useragechecked']) || !$_SESSION['s_UserInfo']['useragechecked'])

				$sql.= "AND cf_ads.adagerestricted=0 AND cf_categories.catagerestricted=0 "; 
			} 
			
			if(isset($_GET['searchtype']) && strtoupper($_GET['searchtype'])=="AND")		{
				$strConnector = "AND";
			} else {
				$strConnector = "OR";
			}
			
			// Parse searchkey
			$phrase = explode(" ", $_GET['searchkey']);
			
			$sql .= " AND (";
			for($i=0; $i<count($phrase); $i++)		{
				$sql .= "(adtitle LIKE '%".$phrase[$i]."%' OR ".
					"adtext LIKE '%".$phrase[$i]."%' OR ".
					"adname LIKE '%".$phrase[$i]."%') ";
				
				// Be sure, that the last array doesnt get an Connectorelement (AND,OR)
				if($i < (count($phrase)-1))	{
					$sql .= $strConnector;
				}
			}
			$sql .= ") ";

			// Order clause
			switch($iSortOrder)		{
				case AD_ORDER_TITLE:
					$sql.= "ORDER BY adtitle ";
					break;
				case AD_ORDER_TITLE_DESC:
					$sql.= "ORDER BY adtitle DESC ";
					break;
				case AD_ORDER_VIEWS:
					$sql.= "ORDER BY adviewed, adindate ";
					break;
				case AD_ORDER_VIEWS_DESC:
					$sql.= "ORDER BY adviewed DESC, adindate ";
					break;
				case AD_ORDER_PICTURES:
					$sql.= "ORDER BY adpiclink<>'', adindate DESC ";
					break;
				case AD_ORDER_INDATE:
					$sql.="ORDER BY adindate ";		
					break;
				default:
					$sql.= "ORDER BY adindate DESC ";
					break;
			}
			
			// Limit
			$sql.= "LIMIT 50";
			
			// Query database 
			$data = $DB->dbselect($sql);
			
			// Save last search
			$_SESSION['s_LastSearch']['skey'] = $_GET['searchkey'];
			$_SESSION['s_LastSearch']['stype'] = $_GET['searchtype'];

			// Log action
			LogActions("SRCP","Searchkey: ".$_GET['searchkey']." - IP: ".$_SERVER['REMOTE_ADDR'],
				(isset($_SESSION['s_UserInfo'])?$_SESSION['s_UserInfo']['userid']:"0") );
		} 
		
	} else {
		// First display
		if(isset($_SESSION['s_LastSearch']['skey']))	{
			$_GET['searchkey'] = $_SESSION['s_LastSearch']['skey'];
		}
		
		if(isset($_SESSION['s_LastSearch']['stype']))	{
			$_GET['searchtype'] = $_SESSION['s_LastSearch']['stype'];
		} else {
			$_GET['searchtype'] = "AND";			
		}
				
		if(isset($_SESSION['s_AdSortOrder']))	{
			$iSortOrder = (integer)$_SESSION['s_AdSortOrder'];			
		}
	}

	
	//
	// Display template
	//
		
	// Build result table
	$strResultTable =  "<table width=\"100%\">".
		"<tr>".
		"<th width=\"7%\">".LANG_HEADLINEPICROW."</th>".
		"<th width=\"48%\">".LANG_HEADLINETITLEROW."</th>".
		"<th width=\"30%\">".LANG_HEADLINEWRITERROW."</th>".
		"<th width=\"10%\">".LANG_HEADLINEDATEROW."</th>".
		"<th width=\"5%\" align=\"right\">".LANG_HEADLINEADVIEWS."</th>".
		"</tr>";
	
	if(!is_array($data) || sizeof($data)==0)	{
		// Keine Daten oder fehler bei der Konnektierung!
		$strResultTable .= "<tr><td colspan=\"5\"><div align=\"center\">".LANG_SRCHNOFOUND."</div></td></tr>";
	} else {	
		
		$PrintLine=0;
		foreach($data as $element)
		{	
			$PrintLine++;
			
			$HighlightTag="";
			if($PrintLine%2==0)	{
				$HighlightTag = " class=\"highlighted\"";
			} else {
				$HighlightTag = " class=\"nonhighlighted\"";
			}
			
			$ThumbPic="";
			if(!empty($element['adpiclink']))	{
				$ThumbPic = "<a href=\"showad.php?adid=".$element['adid']."\">".
					"<img src=\"".GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink']."\" alt=\"".$element['adtitle']."\">".
					"</a>";
			} else {
				$ThumbPic = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg\" alt=\"".LANG_NOPICAVAILABLE."\">";
			}
			$strResultTable .= "<tr".$HighlightTag.">".
				"<td width=\"7%\" class=\"previewimage\">".$ThumbPic."</td>".
				"<td width=\"48%\"><a href=\"showad.php?adid=".$element['adid']."\">".$element['adtitle']."</td>".
   				"<td width=\"30%\">".$element['adname']."<br>(".(!empty($element['adzip'])? $element['adzip']." ":"").$element['adcity'].")</td>".
   		 		"<td width=\"10%\">".FormatDate($element['adindate'])."</td>".
   		 		"<td width=\"5%\" align=\"right\">".$element['adviewed']."</td></tr>";	
		}
	}
	
	$strResultTable.= "</table>";
	
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_TTLSEARCHAD;
	
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/searchads.tpl.php";
	include "inc/footer.inc.php";
	
?>