<?php		

	/**
	 *	Search ads (extended)
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
		

	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	require_once("inc/guielements.inc.php");
	require "inc/adv_categories.inc.php";

	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLEXTSRCH);
	include "inc/header.inc.php";
	
	// Init
	$strMessage = "";
	$bError = "";
	$BreadCrumb = "";		
	$iSortOrder = AD_ORDER_INDATE_DESC;
	$data = array();
	$bSecurityCheck = FALSE;
	
	
	if(GetConfig('SEC_HIDE_AGEREST_ADS') && GetConfig('SEC_FORCE_AGE_REST'))	{
		if(!isset($_SESSION['s_UserInfo']['useragechecked']) || !$_SESSION['s_UserInfo']['useragechecked'])		{
			$bSecurityCheck = TRUE; 
		}
	} 
	
	
	//
	// Process search form
	//		
	if(isset($_GET['search']) && strtoupper($_GET['search'])=="YES")		{	
	
		// Open Database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			echo LANG_DBCONNECTERRORCUST;    
			die();
		}
		
		// Convert/disarm all input vars
		$_GET['skey'] = toSafeString($_GET['skey'], TRUE);
		$_GET['cat'] = toInt($_GET['cat']);
		$_GET['type'] = toInt($_GET['type']);
		$_GET['tmspn'] = toInt($_GET['tmspn']);
		$_GET['country'] = toSafeString($_GET['country'], TRUE);
		$_GET['zip'] = toSafeString($_GET['zip'], TRUE);
		//$_GET['name'] = toSafeString($_GET['name'], TRUE);
		$_GET['so'] = toInt($_GET['so']);	
		$_GET['type'] = toInt($_GET['type']);
		
		
		//
		// Build query
		//
		
		// Base query
		$sql = "SELECT cf_ads.*, ".
			"cf_categories.catname, cf_categories.catagerestricted as CatRest ".
			"FROM cf_ads ".
			"LEFT OUTER JOIN cf_categories ON (cf_ads.adcat = cf_categories.catid) ";
		
		// Filter 
		
		// Security		
		$sql .= "WHERE adchecked=1 ";
		
		if(GetConfig('SEC_HIDE_AGEREST_ADS') && GetConfig('SEC_FORCE_AGE_REST'))	{
			if(!isset($_SESSION['s_UserInfo']['useragechecked']) || !$_SESSION['s_UserInfo']['useragechecked'])		{

				$sql.= "AND cf_ads.adagerestricted=0 AND cf_categories.catagerestricted=0 "; 
			}
		} 
		
		if(isset($_GET['stype']) && strtoupper($_GET['stype'])=="AND")		{
			$strConnector = "AND";
		} else {
			$strConnector = "OR";
		}
		
		if(!empty($_GET['skey']))	{
			// Parse searchkey
			$phrase = explode(" ", $_GET['skey']);
			
			$sql .= " AND (";
			for($i=0; $i<count($phrase); $i++)		{
				$sql .= "(adtitle LIKE '%".$phrase[$i]."%' OR ".
					"adtext LIKE '%".$phrase[$i]."%' OR ".
					"adname LIKE '%".$phrase[$i]."%') ";
				
				// Be sure, that the last array doesnt get an Connectorelement (AND,OR)
				if($i < (count($phrase)-1))	{
					$sql .= $strConnector;
				}
			}
			$sql .= ") ";
		}
			
		// Category filter
		if(!GetConfig('OP_SIMPLE_CATS') && (isset($_GET['subcats']) && strtoupper($_GET['subcats'])=="YES"))		{
			
			if(isset($_GET['cat']) && $_GET['cat']!=(-1)  )	{
			
				// Get all ids of category's subcats
				$oCatManager = new CatTreeManager();
				$oRoot = $oCatManager->GetTreeRoot();
				
				$oTreeWork = new TreeWorks($oRoot);
				$oSubNode = $oTreeWork->GetNodeById((integer)$_GET['cat']);
				
				$oSubTreeWork = new TreeWorks($oSubNode);
				$arrIds = $oSubTreeWork->GetIds();
				
				$sql.= " AND (adcat IN (".implode(",",$arrIds).")) ";
			}					
		
		} else {
			
			if(isset($_GET['cat']) && $_GET['cat']!=(-1)  )	{
				$sql.= " AND (adcat = ".$_GET['cat'].") ";
			}
		}
			
		// Time span
		if(isset($_GET['tmspn']) && $_GET['tmspn']!=TIMESPAN_UNLIMITED)		{		
			
			$iOffSet = 0;
			switch($_GET['tmspn'])	{

				case TIMESPAN_1DAY:
					$iOffSet = 1; break;
				case TIMESPAN_3DAYS:
					$iOffSet = 3; break;
				case TIMESPAN_1WEEK:
					$iOffSet = 7; break;
				case TIMESPAN_2WEEKS:
					$iOffSet = 14; break;
				case TIMESPAN_1MONTH:
					$iOffSet = 30; break;
				default:
					$iOffSet = 360; 
			}
			
			$sql.= "AND (adindate > DATE_SUB(CURDATE(), INTERVAL ".$iOffSet." DAY)) ";
		}
		
		// Ad type
		if(isset($_GET['type']) && $_GET['type']!=(-1))		{
			$sql.= "AND (adtype=".$_GET['type'].") ";
		}
		
		// Zip and country
		if(isset($_GET['country']) && $_GET['country']!="ALL")	{
			$sql.= "AND (adcountry='".$_GET['country']."') ";
		}

		if(isset($_GET['zip']) && !empty($_GET['zip']))		{	
			$sql.= "AND (adzip LIKE '".$_GET['zip']."%') ";
		}
		
		// Inserted by
		if(isset($_GET['name']) && !empty($_GET['name']))	{
			$sql.="AND (adname LIKE '%".$_GET['name']."%') ";
		}
		
		// Set sort order
		if(isset($_GET['so']))	{
			$iSortOrder = (integer)$_GET['so'];
		} elseif(isset($_SESSION['s_AdSortOrder']))	{
			$iSortOrder = (integer)$_SESSION['s_AdSortOrder'];			
		}
		
		// Order clause
		switch($iSortOrder)		{
			case AD_ORDER_TITLE:
				$sql.= "ORDER BY adtitle ";
				break;
			case AD_ORDER_TITLE_DESC:
				$sql.= "ORDER BY adtitle DESC ";
				break;
			case AD_ORDER_VIEWS:
				$sql.= "ORDER BY adviewed, adindate ";
				break;
			case AD_ORDER_VIEWS_DESC:
				$sql.= "ORDER BY adviewed DESC, adindate ";
				break;
			case AD_ORDER_PICTURES:
				$sql.= "ORDER BY adpiclink='', adindate DESC ";
				break;
			case AD_ORDER_PICTURES_DESC:
				$sql.= "ORDER BY adpiclink='' DESC, adindate DESC ";
				break;
			case AD_ORDER_INDATE:
				$sql.="ORDER BY adindate ";		
				break;
			default:
				$sql.= "ORDER BY adindate DESC ";
				break;
		}
			
		// Limit
		$sql.= "LIMIT 50";
		
		// Query database 
		$data = $DB->dbselect($sql);

		// Log search
		$_SESSION['s_LastSearch']['skey'] = $_GET['skey'];
		$_SESSION['s_LastSearch']['type'] = $_GET['type'];
		$_SESSION['s_LastSearch']['cat'] = $_GET['cat'];
		$_SESSION['s_LastSearch']['tmspn'] = $_GET['tmspn']; 
		$_SESSION['s_LastSearch']['country'] = $_GET['country']; 
		$_SESSION['s_LastSearch']['zip'] = $_GET['zip']; 
		//$_SESSION['s_LastSearch']['name'] = $_GET['name']; 
		$_SESSION['s_LastSearch']['so'] = $_GET['so']; 
		$_SESSION['s_LastSearch']['type'] = $_GET['type'];
		
		LogActions("SRCP","Ext-Searchkey: ".$_GET['skey']." - IP: ".
			$_SERVER['REMOTE_ADDR'],(isset($_SESSION['s_UserInfo']['userid'])? $_SESSION['s_UserInfo']['userid']:"0") );

	} else {
		
		// Put in last search details
		$_GET['skey'] = (isset($_SESSION['s_LastSearch']['skey'])?$_SESSION['s_LastSearch']['skey']:"");
		$_GET['stype'] = (isset($_SESSION['s_LastSearch']['stype'])?$_SESSION['s_LastSearch']['stype']:"");
		$_GET['cat'] = (isset($_SESSION['s_LastSearch']['cat'])?$_SESSION['s_LastSearch']['cat']:"");
		$_GET['tmspn'] = (isset($_SESSION['s_LastSearch']['tmspn'])?$_SESSION['s_LastSearch']['tmspn']:"");
		$_GET['country'] = (isset($_SESSION['s_LastSearch']['country'])?$_SESSION['s_LastSearch']['country']:-1);
		$_GET['zip'] = (isset($_SESSION['s_LastSearch']['zip'])?$_SESSION['s_LastSearch']['zip']:"");
		$_GET['name'] = (isset($_SESSION['s_LastSearch']['name'])?$_SESSION['s_LastSearch']['name']:"");
		$_GET['so'] = (isset($_SESSION['s_LastSearch']['so'])?$_SESSION['s_LastSearch']['so']:"");
		$_GET['type'] = (isset($_SESSION['s_LastSearch']['type'])?$_SESSION['s_LastSearch']['type']:-1);
		
	}
			
	
	// Build result table
	$strResultTable =  "<table width=\"100%\">".
		"<tr>".
		"<th width=\"7%\">".LANG_HEADLINEPICROW."</th>".
		"<th width=\"48%\">".LANG_HEADLINETITLEROW."</th>".
		"<th width=\"30%\">".LANG_HEADLINEWRITERROW."</th>".
		"<th width=\"10%\">".LANG_HEADLINEDATEROW."</th>".
		"<th width=\"5%\" align=\"right\">".LANG_HEADLINEADVIEWS."</th>".
		"</tr>";
	
	if(!is_array($data) || sizeof($data)==0)	{
		// Keine Daten oder fehler bei der Konnektierung!
		$strResultTable .= "<tr><td colspan=\"5\"><div align=\"center\">".LANG_SRCHNOFOUND."</div></td></tr>";
	} else {	
		
		$PrintLine=0;
		foreach($data as $element)
		{	
			$PrintLine++;
			
			$HighlightTag="";
			if($PrintLine%2==0)	{
				$HighlightTag = " class=\"highlighted\"";
			} else {
				$HighlightTag = " class=\"nonhighlighted\"";
			}
			
			$ThumbPic="";
			if(!empty($element['adpiclink']))	{
				$ThumbPic = "<a href=\"showad.php?adid=".$element['adid']."\">".
					"<img src=\"".GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink']."\" alt=\"".$element['adtitle']."\"></a>";
			} else {
				$ThumbPic = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg\" alt=\"".LANG_NOPICAVAILABLE."\">";
			}
			$strResultTable .= "<tr".$HighlightTag.">".
				"<td width=\"7%\" class=\"previewimage\">".$ThumbPic."</td>".
				"<td width=\"48%\"><a href=\"showad.php?adid=".$element['adid']."\">".$element['adtitle']."</a>".
					"<br><span class=\"smallsubtitle\">".DecodeAdType($element['adtype'])."</span></td>".
   				"<td width=\"30%\">".$element['adname']."<br>(".(!empty($element['adzip'])? $element['adzip']." ":"").
   				$element['adcity'].")</td>".
   		 		"<td width=\"10%\">".FormatDate($element['adindate'])."</td>".
   		 		"<td width=\"5%\" align=\"right\">".$element['adviewed']."</td></tr>";	
		}
	}
	
	$strResultTable.= "</table>";
	
	
	// 
	// Display extended search form
	//
	if(GetConfig('OP_SIMPLE_CATS'))	{
		$strCategories = GetCategoriesForSelect($_GET['cat'],$bSecurityCheck,true);
	} else {
		// Complexe cats
		$oCatManager = new CatTreeManager();
		$oRoot = $oCatManager->GetTreeRoot();
		$oTreeWork = new CategoryTreeWorks($oRoot);
		$strCategories = $oTreeWork->GetCategoryForSelect($_GET['cat'],TRUE);
	}	
	
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;<a href=\"searchads.php\">".LANG_TTLSEARCHAD."</a>".
		"&nbsp;&gt;&nbsp;".LANG_TTLEXTSRCH;
	
	$strCountrySelect = GetCountriesForDropDown($_GET['country'],TRUE);
	$strTimeSpan = GetTimeSpanForDropDown($_GET['tmspn']);
	$strOrderOptions = GetSortOrderForDropDown($iSortOrder);
	$strAdTypeSelect = GetAdTypesForDropDown($_GET['type'],TRUE,TRUE);	
	
	// Include templates
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/searchextend.tpl.php";
	include "inc/footer.inc.php";

?>